<script setup lang="ts">
import { useEmployStore } from '@/stores/employee'
import { ref } from 'vue'
import type { VForm } from 'vuetify/components'

const employeeStore = useEmployStore()
const refForm = ref<VForm | null>(null)
const onSubmit = async () => {
  const { valid } = await refForm.value!.validate()

  if (!valid) return
  employeeStore.save()
}
const input = ref('')
function extra() {
  employeeStore.searchfor(input.value)
}
</script>

<template>
  <div>
    <v-data-table
      style="background-color: rgba(242, 174, 123, 0.466)"
      :headers="employeeStore.headers"
      :items="employeeStore.Employees"
    >
      <template v-slot:top>
        <v-toolbar flat style="background-color: rgb(173, 105, 53)">
          <v-toolbar-title>Employee</v-toolbar-title>
          <!-- ตรงนี้เป็นช่องค้นหา -->
          <v-text-field
            v-model="input"
            density="compact"
            variant="solo"
            label="Search Name/Phone number"
            append-inner-icon="mdi-magnify"
            single-line
            hide-details
            @click:append-inner="extra"
            @keyup.enter="extra()"
          ></v-text-field>
          <!-- ตรงนี้เป็นปุ่มรีนะ -->
          <v-btn icon="mdi-cached" color="text-black" @click="employeeStore.initialize"></v-btn>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- ใส่Dialog -->
          <v-btn
            style="color: white; background-color: rgb(19, 0, 128)"
            prepend-icon="mdi-cash-multiple"
            @click=""
            >Salary</v-btn
          >
          <v-dialog v-model="employeeStore.dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn
                prepend-icon="mdi-plus"
                outlined
                v-bind="props"
                style="color: white; background-color: green"
              >
                New Employee
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Employee Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="employeeStore.form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="employeeStore.editedEmployee.name"
                          :readonly="employeeStore.loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        >
                        </v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="employeeStore.editedEmployee.tel"
                          :readonly="employeeStore.loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Tel"
                        >
                        </v-text-field>
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-combobox
                          v-model="employeeStore.editedEmployee.status"
                          :items="[
                            { title: 'PartTime', value: 'PartTime' },
                            { title: 'FullTime', value: 'FullTime' }
                          ]"
                          label="Select status"
                          multiple
                          :return-object="false"
                        >
                        </v-combobox>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="employeeStore.editedEmployee.salary"
                          :readonly="employeeStore.loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Salary"
                        >
                        </v-text-field>
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="employeeStore.editedEmployee.dateIn"
                          :readonly="employeeStore.loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="DateIn"
                        >
                        </v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="employeeStore.editedEmployee.checkIn"
                          :readonly="employeeStore.loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="CheckIn"
                        >
                        </v-text-field>
                      </v-col>
                      <v-col>
                        <v-text-field
                          v-model="employeeStore.editedEmployee.checkOut"
                          :readonly="employeeStore.loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="CheckOut"
                        >
                        </v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="employeeStore.closeDialog()">
                  Close
                </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="employeeStore.save()">
                  Save
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- Delete Dialog -->
          <v-dialog v-model="employeeStore.dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="employeeStore.closeDelete"
                  >Cancel</v-btn
                >
                <v-btn color="blue-darken-1" variant="text" @click="employeeStore.deleteItemConfirm"
                  >OK</v-btn
                >
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon
          size="small"
          color="blue-accent-4"
          class="me-2"
          @click="employeeStore.editItem(item)"
        >
          mdi-pencil
        </v-icon>
        <v-icon size="small" color="red-accent-4" @click="employeeStore.deleteItem(item)">
          mdi-delete
        </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="employeeStore.initialize"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>
